unit Unit1;
{ AFRuns Ver2.0  Programmed by AFsoft 2001/02/26 }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Menus, ComCtrls, ShellAPI, Printers ;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MnuFile: TMenuItem;
    MnuNew: TMenuItem;
    MnuOpen: TMenuItem;
    MnuSave: TMenuItem;
    MnuSaveAs: TMenuItem;
    MnuDmy1: TMenuItem;
    MnuExit: TMenuItem;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    StringGrid1: TStringGrid;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    Label3: TLabel;
    Edit3: TEdit;
    Button6: TButton;
    Label4: TLabel;
    SaveDialog1: TSaveDialog;
    Button7: TButton;
    StatusBar1: TStatusBar;
    Label5: TLabel;
    ComboBox1: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure MnuNewClick(Sender: TObject);
    procedure MnuExitClick(Sender: TObject);
    procedure MnuOpenClick(Sender: TObject);
    procedure MnuSaveClick(Sender: TObject);
    procedure MnuSaveAsClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private 錾 }
    DefPath1,DefPath2 : String ;
	 LCount : Integer ;
    FName : String ;
	 function  FileLoad(fn:String):Boolean ;
	 procedure FileSave(fn:String);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{s~bԑ҂}
{@@in :T ... EGCg[~b]}
{@@out: --- }
{()ɎԂvł͂܂}
procedure Delay(T: longint);
var
   Finish: longint;
begin
   Finish := LongInt(GetTickCount) + T ;
   repeat
       Application.ProcessMessages
   until LongInt(GetTickCount) > Finish
end;

{ Start }
procedure TForm1.FormShow(Sender: TObject);
var
	i : Integer ;
   s : String ;
begin
	DefPath1 := ExtractFilePath(ParamStr(0));
	DefPath2 := DefPath1 ;
   LCount := 0 ;
   FName := '' ;

	Edit1.Text := '' ;
   Edit2.Text := '' ;
   Edit3.Text := '' ;
	with StringGrid1 do begin
   	Cells[0,0] := 'No.' ;
   	Cells[1,0] := 'Delay' ;
   	Cells[2,0] := 'ExeName' ;
   	Cells[3,0] := 'Parameter' ;
		RowCount := 2 ;
      Cells[0,1] := '' ;
      Cells[1,1] := '' ;
      Cells[2,1] := '' ;
      Cells[3,1] := '' ;
      ColWidths[1] :=  64 ;
      ColWidths[2] := 200 ;
      ColWidths[3] := 200 ;
   end;
	// v^擾
	ComboBox1.Items.Clear ;
   ComboBox1.Items.Add('');
   for i:=0 to Printer.Printers.Count-1 do begin
      s := Printer.Printers[i] ;
      ComboBox1.Items.Add(s);
   end;
   ComboBox1.ItemIndex := 0 ;

	{ if specified the Parameter,automatically run }
	if (ParamCount = 0) then exit ;
	FName := ParamStr(1);
   Form1.Caption := 'AFRuns | ' + FName ;
	{ File Load }
	if (FileLoad(FName)) then begin
      Button7Click(Sender);	{ Run }
      close ;
   end
   else
      MnuNewClick(Sender);
end;

{ [Browse] }
procedure TForm1.Button1Click(Sender: TObject);
begin
   OpenDialog1.InitialDir := DefPath1 ;
	OpenDialog1.Filter := 'EXE Files(*.exe)|*.exe|All Files(*.*)|*.*' ;
	OpenDialog1.DefaultExt := '' ;
	if (OpenDialog1.Execute) then begin
		Edit2.Text := OpenDialog1.FileName ;
		DefPath1 := ExtractFilePath(OpenDialog1.FileName);
   end;
end;

{ [Add] }
procedure TForm1.Button2Click(Sender: TObject);
var i,j : Integer ;
begin
	{ Check:Delay }
	if (Edit1.Text = '') then
   	i := 0
   else begin
   	Val(Edit1.Text,i,j);
      if (j <> 0) then
      	i := 0 ;
		if (i < 0) then
      	i := 0 ;
   end;
   Edit1.Text := IntToStr(i);
   { Add }
	Inc(LCount);
	with StringGrid1 do begin
   	Cells[0,LCount] := IntToStr(LCount) ;
   	Cells[1,LCount] := Edit1.Text ;
   	Cells[2,LCount] := Edit2.Text ;
   	Cells[3,LCount] := Edit3.Text ;
		RowCount := LCount + 1 ;
	end;
end;

{ [Insert] }
procedure TForm1.Button3Click(Sender: TObject);
var i,j,k : Integer ;
begin
	{ Check:Delay }
	if (Edit1.Text = '') then
   	i := 0
   else begin
   	Val(Edit1.Text,i,j);
      if (j <> 0) then
      	i := 0 ;
		if (i < 0) then
      	i := 0 ;
   end;
   Edit1.Text := IntToStr(i);
	{ Sort }
	Inc(LCount);
	StringGrid1.RowCount := LCount + 1 ;
	k := LCount ;
	if (LCount > 0) then begin
		with StringGrid1 do begin
   		k := Row ;
      	for i:=LCount downto k do begin
				Cells[0,i+1] := IntToStr(i+1) ;
				for j:=1 to 3 do
					Cells[j,i+1] := Cells[j,i] ;
			end;
      end;
   end;
   { Insert }
	with StringGrid1 do begin
   	Cells[0,k] := IntToStr(k) ;
   	Cells[1,k] := Edit1.Text ;
   	Cells[2,k] := Edit2.Text ;
   	Cells[3,k] := Edit3.Text ;
	end;
end;

{ [Delete] }
procedure TForm1.Button4Click(Sender: TObject);
var i,j,k : Integer ;
begin
	if (LCount = 0) then Exit ;
	with StringGrid1 do begin
		{ Sort }
  		k := Row ;
     	for i:=k to LCount-1 do begin
			Cells[0,i] := IntToStr(i) ;
			for j:=1 to 3 do
				Cells[j,i] := Cells[j,i+1] ;
		end;
		{ Del }
		for j:=0 to 3 do
			Cells[j,LCount] := '' ;
		Dec(LCount);
		if (LCount = 0) then
      	RowCount := 2
      else
			RowCount := LCount + 1 ;
   end;
end;

{ {Edit] }
procedure TForm1.Button5Click(Sender: TObject);
var i,j,k : Integer ;
begin
	if (LCount = 0) then Exit ;
	{ Check:Delay }
	if (Edit1.Text = '') then
   	i := 0
   else begin
   	Val(Edit1.Text,i,j);
      if (j <> 0) then
      	i := 0 ;
		if (i < 0) then
      	i := 0 ;
   end;
   Edit1.Text := IntToStr(i);
	{ Edit }
	with StringGrid1 do begin
  		k := Row ;
   	Cells[1,k] := Edit1.Text ;
   	Cells[2,k] := Edit2.Text ;
   	Cells[3,k] := Edit3.Text ;
	end;
end;

{ {Pick] }
procedure TForm1.Button6Click(Sender: TObject);
var k : Integer ;
begin
	if (LCount = 0) then Exit ;
	with StringGrid1 do begin
  		k := Row ;
     	Edit1.Text := Cells[1,k] ;
     	Edit2.Text := Cells[2,k] ;
     	Edit3.Text := Cells[3,k] ;
	end;
end;

{ Menu|New }
procedure TForm1.MnuNewClick(Sender: TObject);
begin
   LCount := 0 ;
   FName := '' ;
   Form1.Caption := 'AFRuns';

	Edit1.Text := '' ;
   Edit2.Text := '' ;
   Edit3.Text := '' ;
	with StringGrid1 do begin
		RowCount := 2 ;
      Cells[0,1] := '' ;
      Cells[1,1] := '' ;
      Cells[2,1] := '' ;
      Cells[3,1] := '' ;
      ColWidths[0] :=  40 ;
      ColWidths[1] :=  64 ;
      ColWidths[2] := 200 ;
      ColWidths[3] := 200 ;
   end;
   ComboBox1.ItemIndex := 0 ;
end;

{ Menu|Exit }
procedure TForm1.MnuExitClick(Sender: TObject);
begin
	close ;
end;

{ Menu|open }
procedure TForm1.MnuOpenClick(Sender: TObject);
begin
   OpenDialog1.InitialDir := DefPath2 ;
	OpenDialog1.Filter := 'FileList Files(*.lst)|*.lst' ;
	OpenDialog1.DefaultExt := 'lst' ;
	if (OpenDialog1.Execute) then begin
		FName := OpenDialog1.FileName ;
		DefPath2 := ExtractFilePath(FName);
	   Form1.Caption := 'AFRuns | ' + FName ;
		{ File Load }
		if (FileLoad(FName) = False) then
         MnuNewClick(Sender);
   end;
end;

{ Menu|Save }
procedure TForm1.MnuSaveClick(Sender: TObject);
begin
	if (FName = '') then
   	MnuSaveAsClick(Sender)
   else
      FileSave(FName);
end;

{ Menu|SaveAs }
procedure TForm1.MnuSaveAsClick(Sender: TObject);
begin
   SaveDialog1.InitialDir := DefPath2 ;
	SaveDialog1.Filter := 'FileList Files(*.lst)|*.lst' ;
	SaveDialog1.DefaultExt := 'lst' ;
	SaveDialog1.FileName := FName ;
	if (SaveDialog1.Execute) then begin
		FName := SaveDialog1.FileName ;
      FileSave(FName);
	   Form1.Caption := 'AFRuns | ' + FName ;
	end;
end;

{ FileLoad }
function TForm1.FileLoad(fn:String):Boolean ;
var F:TextFile ;
	i,j : Integer ;
	s : String ;
begin
	try
		AssignFile(F,fn);
   	Reset(F);

      ReadLn(F, i);	if (i < 0)or(i >= ComboBox1.Items.Count) then i := 0 ;
      ComboBox1.ItemIndex := i ;

      ReadLn(F, LCount);
		if (LCount <= 0) then begin
			CloseFile(F);
			Result := False ;
         exit ;
      end;
		StringGrid1.RowCount := LCount + 1 ;
      for i:=1 to LCount do begin
        	StringGrid1.Cells[0,i] := IntToStr(i) ;
      	for j:=1 to 3 do begin
         	ReadLn(F, s);
            StringGrid1.Cells[j,i] := s ;
			end;
      end;

		CloseFile(F);
		Result := True ;
   except
		CloseFile(F);
		Result := False ;
   end;
end;

{ FileSave }
procedure TForm1.FileSave(fn:String);
var F:TextFile ;
	i,j : Integer ;
   s : String ;
begin
	try
		AssignFile(F,fn);
   	Rewrite(F);

      i := ComboBox1.ItemIndex ;
      WriteLn(F, i);

      WriteLn(F, LCount);
      for i:=1 to LCount do begin
      	for j:=1 to 3 do begin
         	s := StringGrid1.Cells[j,i] ;
         	WriteLn(F, s) ;
			end;
      end;

		CloseFile(F);
   except
		CloseFile(F);
		if (FileExists(fn)) then
      	DeleteFile(fn);
   end;
end;

{ [Run] }
procedure TForm1.Button7Click(Sender: TObject);
var i,j : Integer ;
	l : LongInt ;
	s1,s2 : String ;

	DevMode: THandle;
	Device,Driver,Port: array[0..79] of Char;
begin
	// w肵v^ʏ̃v^ɂ
	i := ComboBox1.ItemIndex ;
   if (i > 0) then begin
		Printer.PrinterIndex := i-1 ;	// ړĨv^
		Printer.GetPrinter(Device,Driver,Port,DevMode);
		s1 := Device + ',' + Driver + ',' + Port;
		WriteProfileString('windows','device',PChar(s1));
		SendMessage(HWND_BROADCAST,WM_WININICHANGE,0,
			Longint(PChar('windows')));
   end;

	for i:=1 to LCount do begin
		s1 := StringGrid1.Cells[1,i] ;
      if (s1 = '') then
      	l := 0
      else begin
 			Val(s1,l,j);
         if (j <> 0) then
         	l := 0 ;
         if (l < 0) then
         	l := 0 ;
         if (l > 3600) then
         	l := 3600 ;		{ Wait Max(1h) }
      end;
		s1 := StringGrid1.Cells[2,i] ;
		s2 := StringGrid1.Cells[3,i] ;
      Statusbar1.Panels[0].Text := IntToStr(i);
      Statusbar1.Panels[1].Text := s1 ;
      Statusbar1.Panels[2].Text := s2 ;
		l := l * 1000 ;
		Delay(l);
	  	ShellExecute(Handle, 'OPEN', PChar(s1),
							PChar(s2), '', SW_SHOW);
   end;
   Statusbar1.Panels[0].Text := '' ;
   Statusbar1.Panels[1].Text := '' ;
   Statusbar1.Panels[2].Text := '' ;
end;

end.
